// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: commonmodule/commonmodule.proto

package openfmb.commonmodule;

/**
 * <pre>
 * Frequency-Trip Function
 * </pre>
 *
 * Protobuf type {@code commonmodule.TmHzCSG}
 */
public final class TmHzCSG extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:commonmodule.TmHzCSG)
    TmHzCSGOrBuilder {
private static final long serialVersionUID = 0L;
  // Use TmHzCSG.newBuilder() to construct.
  private TmHzCSG(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private TmHzCSG() {
    overCrvPts_ = java.util.Collections.emptyList();
    underCrvPts_ = java.util.Collections.emptyList();
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new TmHzCSG();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_TmHzCSG_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_TmHzCSG_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.commonmodule.TmHzCSG.class, openfmb.commonmodule.TmHzCSG.Builder.class);
  }

  public static final int OVERCRVPTS_FIELD_NUMBER = 1;
  @SuppressWarnings("serial")
  private java.util.List<openfmb.commonmodule.TmHzPoint> overCrvPts_;
  /**
   * <pre>
   * HF Trip Curve Points
   * </pre>
   *
   * <code>repeated .commonmodule.TmHzPoint overCrvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public java.util.List<openfmb.commonmodule.TmHzPoint> getOverCrvPtsList() {
    return overCrvPts_;
  }
  /**
   * <pre>
   * HF Trip Curve Points
   * </pre>
   *
   * <code>repeated .commonmodule.TmHzPoint overCrvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public java.util.List<? extends openfmb.commonmodule.TmHzPointOrBuilder> 
      getOverCrvPtsOrBuilderList() {
    return overCrvPts_;
  }
  /**
   * <pre>
   * HF Trip Curve Points
   * </pre>
   *
   * <code>repeated .commonmodule.TmHzPoint overCrvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public int getOverCrvPtsCount() {
    return overCrvPts_.size();
  }
  /**
   * <pre>
   * HF Trip Curve Points
   * </pre>
   *
   * <code>repeated .commonmodule.TmHzPoint overCrvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.TmHzPoint getOverCrvPts(int index) {
    return overCrvPts_.get(index);
  }
  /**
   * <pre>
   * HF Trip Curve Points
   * </pre>
   *
   * <code>repeated .commonmodule.TmHzPoint overCrvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.TmHzPointOrBuilder getOverCrvPtsOrBuilder(
      int index) {
    return overCrvPts_.get(index);
  }

  public static final int UNDERCRVPTS_FIELD_NUMBER = 2;
  @SuppressWarnings("serial")
  private java.util.List<openfmb.commonmodule.TmHzPoint> underCrvPts_;
  /**
   * <pre>
   * LF Trip Curve Points
   * </pre>
   *
   * <code>repeated .commonmodule.TmHzPoint underCrvPts = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public java.util.List<openfmb.commonmodule.TmHzPoint> getUnderCrvPtsList() {
    return underCrvPts_;
  }
  /**
   * <pre>
   * LF Trip Curve Points
   * </pre>
   *
   * <code>repeated .commonmodule.TmHzPoint underCrvPts = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public java.util.List<? extends openfmb.commonmodule.TmHzPointOrBuilder> 
      getUnderCrvPtsOrBuilderList() {
    return underCrvPts_;
  }
  /**
   * <pre>
   * LF Trip Curve Points
   * </pre>
   *
   * <code>repeated .commonmodule.TmHzPoint underCrvPts = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public int getUnderCrvPtsCount() {
    return underCrvPts_.size();
  }
  /**
   * <pre>
   * LF Trip Curve Points
   * </pre>
   *
   * <code>repeated .commonmodule.TmHzPoint underCrvPts = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.TmHzPoint getUnderCrvPts(int index) {
    return underCrvPts_.get(index);
  }
  /**
   * <pre>
   * LF Trip Curve Points
   * </pre>
   *
   * <code>repeated .commonmodule.TmHzPoint underCrvPts = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.TmHzPointOrBuilder getUnderCrvPtsOrBuilder(
      int index) {
    return underCrvPts_.get(index);
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    for (int i = 0; i < overCrvPts_.size(); i++) {
      output.writeMessage(1, overCrvPts_.get(i));
    }
    for (int i = 0; i < underCrvPts_.size(); i++) {
      output.writeMessage(2, underCrvPts_.get(i));
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    for (int i = 0; i < overCrvPts_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, overCrvPts_.get(i));
    }
    for (int i = 0; i < underCrvPts_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, underCrvPts_.get(i));
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.commonmodule.TmHzCSG)) {
      return super.equals(obj);
    }
    openfmb.commonmodule.TmHzCSG other = (openfmb.commonmodule.TmHzCSG) obj;

    if (!getOverCrvPtsList()
        .equals(other.getOverCrvPtsList())) return false;
    if (!getUnderCrvPtsList()
        .equals(other.getUnderCrvPtsList())) return false;
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (getOverCrvPtsCount() > 0) {
      hash = (37 * hash) + OVERCRVPTS_FIELD_NUMBER;
      hash = (53 * hash) + getOverCrvPtsList().hashCode();
    }
    if (getUnderCrvPtsCount() > 0) {
      hash = (37 * hash) + UNDERCRVPTS_FIELD_NUMBER;
      hash = (53 * hash) + getUnderCrvPtsList().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.commonmodule.TmHzCSG parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.TmHzCSG parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.TmHzCSG parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.TmHzCSG parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.TmHzCSG parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.TmHzCSG parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.TmHzCSG parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.TmHzCSG parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.TmHzCSG parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.TmHzCSG parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.TmHzCSG parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.TmHzCSG parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.commonmodule.TmHzCSG prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Frequency-Trip Function
   * </pre>
   *
   * Protobuf type {@code commonmodule.TmHzCSG}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:commonmodule.TmHzCSG)
      openfmb.commonmodule.TmHzCSGOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_TmHzCSG_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_TmHzCSG_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.commonmodule.TmHzCSG.class, openfmb.commonmodule.TmHzCSG.Builder.class);
    }

    // Construct using openfmb.commonmodule.TmHzCSG.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      if (overCrvPtsBuilder_ == null) {
        overCrvPts_ = java.util.Collections.emptyList();
      } else {
        overCrvPts_ = null;
        overCrvPtsBuilder_.clear();
      }
      bitField0_ = (bitField0_ & ~0x00000001);
      if (underCrvPtsBuilder_ == null) {
        underCrvPts_ = java.util.Collections.emptyList();
      } else {
        underCrvPts_ = null;
        underCrvPtsBuilder_.clear();
      }
      bitField0_ = (bitField0_ & ~0x00000002);
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_TmHzCSG_descriptor;
    }

    @java.lang.Override
    public openfmb.commonmodule.TmHzCSG getDefaultInstanceForType() {
      return openfmb.commonmodule.TmHzCSG.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.commonmodule.TmHzCSG build() {
      openfmb.commonmodule.TmHzCSG result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.commonmodule.TmHzCSG buildPartial() {
      openfmb.commonmodule.TmHzCSG result = new openfmb.commonmodule.TmHzCSG(this);
      buildPartialRepeatedFields(result);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartialRepeatedFields(openfmb.commonmodule.TmHzCSG result) {
      if (overCrvPtsBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0)) {
          overCrvPts_ = java.util.Collections.unmodifiableList(overCrvPts_);
          bitField0_ = (bitField0_ & ~0x00000001);
        }
        result.overCrvPts_ = overCrvPts_;
      } else {
        result.overCrvPts_ = overCrvPtsBuilder_.build();
      }
      if (underCrvPtsBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0)) {
          underCrvPts_ = java.util.Collections.unmodifiableList(underCrvPts_);
          bitField0_ = (bitField0_ & ~0x00000002);
        }
        result.underCrvPts_ = underCrvPts_;
      } else {
        result.underCrvPts_ = underCrvPtsBuilder_.build();
      }
    }

    private void buildPartial0(openfmb.commonmodule.TmHzCSG result) {
      int from_bitField0_ = bitField0_;
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.commonmodule.TmHzCSG) {
        return mergeFrom((openfmb.commonmodule.TmHzCSG)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.commonmodule.TmHzCSG other) {
      if (other == openfmb.commonmodule.TmHzCSG.getDefaultInstance()) return this;
      if (overCrvPtsBuilder_ == null) {
        if (!other.overCrvPts_.isEmpty()) {
          if (overCrvPts_.isEmpty()) {
            overCrvPts_ = other.overCrvPts_;
            bitField0_ = (bitField0_ & ~0x00000001);
          } else {
            ensureOverCrvPtsIsMutable();
            overCrvPts_.addAll(other.overCrvPts_);
          }
          onChanged();
        }
      } else {
        if (!other.overCrvPts_.isEmpty()) {
          if (overCrvPtsBuilder_.isEmpty()) {
            overCrvPtsBuilder_.dispose();
            overCrvPtsBuilder_ = null;
            overCrvPts_ = other.overCrvPts_;
            bitField0_ = (bitField0_ & ~0x00000001);
            overCrvPtsBuilder_ = 
              com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                 getOverCrvPtsFieldBuilder() : null;
          } else {
            overCrvPtsBuilder_.addAllMessages(other.overCrvPts_);
          }
        }
      }
      if (underCrvPtsBuilder_ == null) {
        if (!other.underCrvPts_.isEmpty()) {
          if (underCrvPts_.isEmpty()) {
            underCrvPts_ = other.underCrvPts_;
            bitField0_ = (bitField0_ & ~0x00000002);
          } else {
            ensureUnderCrvPtsIsMutable();
            underCrvPts_.addAll(other.underCrvPts_);
          }
          onChanged();
        }
      } else {
        if (!other.underCrvPts_.isEmpty()) {
          if (underCrvPtsBuilder_.isEmpty()) {
            underCrvPtsBuilder_.dispose();
            underCrvPtsBuilder_ = null;
            underCrvPts_ = other.underCrvPts_;
            bitField0_ = (bitField0_ & ~0x00000002);
            underCrvPtsBuilder_ = 
              com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                 getUnderCrvPtsFieldBuilder() : null;
          } else {
            underCrvPtsBuilder_.addAllMessages(other.underCrvPts_);
          }
        }
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              openfmb.commonmodule.TmHzPoint m =
                  input.readMessage(
                      openfmb.commonmodule.TmHzPoint.parser(),
                      extensionRegistry);
              if (overCrvPtsBuilder_ == null) {
                ensureOverCrvPtsIsMutable();
                overCrvPts_.add(m);
              } else {
                overCrvPtsBuilder_.addMessage(m);
              }
              break;
            } // case 10
            case 18: {
              openfmb.commonmodule.TmHzPoint m =
                  input.readMessage(
                      openfmb.commonmodule.TmHzPoint.parser(),
                      extensionRegistry);
              if (underCrvPtsBuilder_ == null) {
                ensureUnderCrvPtsIsMutable();
                underCrvPts_.add(m);
              } else {
                underCrvPtsBuilder_.addMessage(m);
              }
              break;
            } // case 18
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private java.util.List<openfmb.commonmodule.TmHzPoint> overCrvPts_ =
      java.util.Collections.emptyList();
    private void ensureOverCrvPtsIsMutable() {
      if (!((bitField0_ & 0x00000001) != 0)) {
        overCrvPts_ = new java.util.ArrayList<openfmb.commonmodule.TmHzPoint>(overCrvPts_);
        bitField0_ |= 0x00000001;
       }
    }

    private com.google.protobuf.RepeatedFieldBuilderV3<
        openfmb.commonmodule.TmHzPoint, openfmb.commonmodule.TmHzPoint.Builder, openfmb.commonmodule.TmHzPointOrBuilder> overCrvPtsBuilder_;

    /**
     * <pre>
     * HF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint overCrvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public java.util.List<openfmb.commonmodule.TmHzPoint> getOverCrvPtsList() {
      if (overCrvPtsBuilder_ == null) {
        return java.util.Collections.unmodifiableList(overCrvPts_);
      } else {
        return overCrvPtsBuilder_.getMessageList();
      }
    }
    /**
     * <pre>
     * HF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint overCrvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public int getOverCrvPtsCount() {
      if (overCrvPtsBuilder_ == null) {
        return overCrvPts_.size();
      } else {
        return overCrvPtsBuilder_.getCount();
      }
    }
    /**
     * <pre>
     * HF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint overCrvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.TmHzPoint getOverCrvPts(int index) {
      if (overCrvPtsBuilder_ == null) {
        return overCrvPts_.get(index);
      } else {
        return overCrvPtsBuilder_.getMessage(index);
      }
    }
    /**
     * <pre>
     * HF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint overCrvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setOverCrvPts(
        int index, openfmb.commonmodule.TmHzPoint value) {
      if (overCrvPtsBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureOverCrvPtsIsMutable();
        overCrvPts_.set(index, value);
        onChanged();
      } else {
        overCrvPtsBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * HF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint overCrvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setOverCrvPts(
        int index, openfmb.commonmodule.TmHzPoint.Builder builderForValue) {
      if (overCrvPtsBuilder_ == null) {
        ensureOverCrvPtsIsMutable();
        overCrvPts_.set(index, builderForValue.build());
        onChanged();
      } else {
        overCrvPtsBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * HF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint overCrvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder addOverCrvPts(openfmb.commonmodule.TmHzPoint value) {
      if (overCrvPtsBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureOverCrvPtsIsMutable();
        overCrvPts_.add(value);
        onChanged();
      } else {
        overCrvPtsBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     * <pre>
     * HF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint overCrvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder addOverCrvPts(
        int index, openfmb.commonmodule.TmHzPoint value) {
      if (overCrvPtsBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureOverCrvPtsIsMutable();
        overCrvPts_.add(index, value);
        onChanged();
      } else {
        overCrvPtsBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * HF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint overCrvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder addOverCrvPts(
        openfmb.commonmodule.TmHzPoint.Builder builderForValue) {
      if (overCrvPtsBuilder_ == null) {
        ensureOverCrvPtsIsMutable();
        overCrvPts_.add(builderForValue.build());
        onChanged();
      } else {
        overCrvPtsBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * HF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint overCrvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder addOverCrvPts(
        int index, openfmb.commonmodule.TmHzPoint.Builder builderForValue) {
      if (overCrvPtsBuilder_ == null) {
        ensureOverCrvPtsIsMutable();
        overCrvPts_.add(index, builderForValue.build());
        onChanged();
      } else {
        overCrvPtsBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * HF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint overCrvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder addAllOverCrvPts(
        java.lang.Iterable<? extends openfmb.commonmodule.TmHzPoint> values) {
      if (overCrvPtsBuilder_ == null) {
        ensureOverCrvPtsIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(
            values, overCrvPts_);
        onChanged();
      } else {
        overCrvPtsBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     * <pre>
     * HF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint overCrvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearOverCrvPts() {
      if (overCrvPtsBuilder_ == null) {
        overCrvPts_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000001);
        onChanged();
      } else {
        overCrvPtsBuilder_.clear();
      }
      return this;
    }
    /**
     * <pre>
     * HF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint overCrvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder removeOverCrvPts(int index) {
      if (overCrvPtsBuilder_ == null) {
        ensureOverCrvPtsIsMutable();
        overCrvPts_.remove(index);
        onChanged();
      } else {
        overCrvPtsBuilder_.remove(index);
      }
      return this;
    }
    /**
     * <pre>
     * HF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint overCrvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.TmHzPoint.Builder getOverCrvPtsBuilder(
        int index) {
      return getOverCrvPtsFieldBuilder().getBuilder(index);
    }
    /**
     * <pre>
     * HF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint overCrvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.TmHzPointOrBuilder getOverCrvPtsOrBuilder(
        int index) {
      if (overCrvPtsBuilder_ == null) {
        return overCrvPts_.get(index);  } else {
        return overCrvPtsBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     * <pre>
     * HF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint overCrvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public java.util.List<? extends openfmb.commonmodule.TmHzPointOrBuilder> 
         getOverCrvPtsOrBuilderList() {
      if (overCrvPtsBuilder_ != null) {
        return overCrvPtsBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(overCrvPts_);
      }
    }
    /**
     * <pre>
     * HF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint overCrvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.TmHzPoint.Builder addOverCrvPtsBuilder() {
      return getOverCrvPtsFieldBuilder().addBuilder(
          openfmb.commonmodule.TmHzPoint.getDefaultInstance());
    }
    /**
     * <pre>
     * HF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint overCrvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.TmHzPoint.Builder addOverCrvPtsBuilder(
        int index) {
      return getOverCrvPtsFieldBuilder().addBuilder(
          index, openfmb.commonmodule.TmHzPoint.getDefaultInstance());
    }
    /**
     * <pre>
     * HF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint overCrvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public java.util.List<openfmb.commonmodule.TmHzPoint.Builder> 
         getOverCrvPtsBuilderList() {
      return getOverCrvPtsFieldBuilder().getBuilderList();
    }
    private com.google.protobuf.RepeatedFieldBuilderV3<
        openfmb.commonmodule.TmHzPoint, openfmb.commonmodule.TmHzPoint.Builder, openfmb.commonmodule.TmHzPointOrBuilder> 
        getOverCrvPtsFieldBuilder() {
      if (overCrvPtsBuilder_ == null) {
        overCrvPtsBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
            openfmb.commonmodule.TmHzPoint, openfmb.commonmodule.TmHzPoint.Builder, openfmb.commonmodule.TmHzPointOrBuilder>(
                overCrvPts_,
                ((bitField0_ & 0x00000001) != 0),
                getParentForChildren(),
                isClean());
        overCrvPts_ = null;
      }
      return overCrvPtsBuilder_;
    }

    private java.util.List<openfmb.commonmodule.TmHzPoint> underCrvPts_ =
      java.util.Collections.emptyList();
    private void ensureUnderCrvPtsIsMutable() {
      if (!((bitField0_ & 0x00000002) != 0)) {
        underCrvPts_ = new java.util.ArrayList<openfmb.commonmodule.TmHzPoint>(underCrvPts_);
        bitField0_ |= 0x00000002;
       }
    }

    private com.google.protobuf.RepeatedFieldBuilderV3<
        openfmb.commonmodule.TmHzPoint, openfmb.commonmodule.TmHzPoint.Builder, openfmb.commonmodule.TmHzPointOrBuilder> underCrvPtsBuilder_;

    /**
     * <pre>
     * LF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint underCrvPts = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public java.util.List<openfmb.commonmodule.TmHzPoint> getUnderCrvPtsList() {
      if (underCrvPtsBuilder_ == null) {
        return java.util.Collections.unmodifiableList(underCrvPts_);
      } else {
        return underCrvPtsBuilder_.getMessageList();
      }
    }
    /**
     * <pre>
     * LF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint underCrvPts = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public int getUnderCrvPtsCount() {
      if (underCrvPtsBuilder_ == null) {
        return underCrvPts_.size();
      } else {
        return underCrvPtsBuilder_.getCount();
      }
    }
    /**
     * <pre>
     * LF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint underCrvPts = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.TmHzPoint getUnderCrvPts(int index) {
      if (underCrvPtsBuilder_ == null) {
        return underCrvPts_.get(index);
      } else {
        return underCrvPtsBuilder_.getMessage(index);
      }
    }
    /**
     * <pre>
     * LF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint underCrvPts = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setUnderCrvPts(
        int index, openfmb.commonmodule.TmHzPoint value) {
      if (underCrvPtsBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureUnderCrvPtsIsMutable();
        underCrvPts_.set(index, value);
        onChanged();
      } else {
        underCrvPtsBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * LF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint underCrvPts = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setUnderCrvPts(
        int index, openfmb.commonmodule.TmHzPoint.Builder builderForValue) {
      if (underCrvPtsBuilder_ == null) {
        ensureUnderCrvPtsIsMutable();
        underCrvPts_.set(index, builderForValue.build());
        onChanged();
      } else {
        underCrvPtsBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * LF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint underCrvPts = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder addUnderCrvPts(openfmb.commonmodule.TmHzPoint value) {
      if (underCrvPtsBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureUnderCrvPtsIsMutable();
        underCrvPts_.add(value);
        onChanged();
      } else {
        underCrvPtsBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     * <pre>
     * LF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint underCrvPts = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder addUnderCrvPts(
        int index, openfmb.commonmodule.TmHzPoint value) {
      if (underCrvPtsBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureUnderCrvPtsIsMutable();
        underCrvPts_.add(index, value);
        onChanged();
      } else {
        underCrvPtsBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * LF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint underCrvPts = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder addUnderCrvPts(
        openfmb.commonmodule.TmHzPoint.Builder builderForValue) {
      if (underCrvPtsBuilder_ == null) {
        ensureUnderCrvPtsIsMutable();
        underCrvPts_.add(builderForValue.build());
        onChanged();
      } else {
        underCrvPtsBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * LF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint underCrvPts = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder addUnderCrvPts(
        int index, openfmb.commonmodule.TmHzPoint.Builder builderForValue) {
      if (underCrvPtsBuilder_ == null) {
        ensureUnderCrvPtsIsMutable();
        underCrvPts_.add(index, builderForValue.build());
        onChanged();
      } else {
        underCrvPtsBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * LF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint underCrvPts = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder addAllUnderCrvPts(
        java.lang.Iterable<? extends openfmb.commonmodule.TmHzPoint> values) {
      if (underCrvPtsBuilder_ == null) {
        ensureUnderCrvPtsIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(
            values, underCrvPts_);
        onChanged();
      } else {
        underCrvPtsBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     * <pre>
     * LF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint underCrvPts = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearUnderCrvPts() {
      if (underCrvPtsBuilder_ == null) {
        underCrvPts_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000002);
        onChanged();
      } else {
        underCrvPtsBuilder_.clear();
      }
      return this;
    }
    /**
     * <pre>
     * LF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint underCrvPts = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder removeUnderCrvPts(int index) {
      if (underCrvPtsBuilder_ == null) {
        ensureUnderCrvPtsIsMutable();
        underCrvPts_.remove(index);
        onChanged();
      } else {
        underCrvPtsBuilder_.remove(index);
      }
      return this;
    }
    /**
     * <pre>
     * LF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint underCrvPts = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.TmHzPoint.Builder getUnderCrvPtsBuilder(
        int index) {
      return getUnderCrvPtsFieldBuilder().getBuilder(index);
    }
    /**
     * <pre>
     * LF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint underCrvPts = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.TmHzPointOrBuilder getUnderCrvPtsOrBuilder(
        int index) {
      if (underCrvPtsBuilder_ == null) {
        return underCrvPts_.get(index);  } else {
        return underCrvPtsBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     * <pre>
     * LF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint underCrvPts = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public java.util.List<? extends openfmb.commonmodule.TmHzPointOrBuilder> 
         getUnderCrvPtsOrBuilderList() {
      if (underCrvPtsBuilder_ != null) {
        return underCrvPtsBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(underCrvPts_);
      }
    }
    /**
     * <pre>
     * LF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint underCrvPts = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.TmHzPoint.Builder addUnderCrvPtsBuilder() {
      return getUnderCrvPtsFieldBuilder().addBuilder(
          openfmb.commonmodule.TmHzPoint.getDefaultInstance());
    }
    /**
     * <pre>
     * LF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint underCrvPts = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.TmHzPoint.Builder addUnderCrvPtsBuilder(
        int index) {
      return getUnderCrvPtsFieldBuilder().addBuilder(
          index, openfmb.commonmodule.TmHzPoint.getDefaultInstance());
    }
    /**
     * <pre>
     * LF Trip Curve Points
     * </pre>
     *
     * <code>repeated .commonmodule.TmHzPoint underCrvPts = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public java.util.List<openfmb.commonmodule.TmHzPoint.Builder> 
         getUnderCrvPtsBuilderList() {
      return getUnderCrvPtsFieldBuilder().getBuilderList();
    }
    private com.google.protobuf.RepeatedFieldBuilderV3<
        openfmb.commonmodule.TmHzPoint, openfmb.commonmodule.TmHzPoint.Builder, openfmb.commonmodule.TmHzPointOrBuilder> 
        getUnderCrvPtsFieldBuilder() {
      if (underCrvPtsBuilder_ == null) {
        underCrvPtsBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
            openfmb.commonmodule.TmHzPoint, openfmb.commonmodule.TmHzPoint.Builder, openfmb.commonmodule.TmHzPointOrBuilder>(
                underCrvPts_,
                ((bitField0_ & 0x00000002) != 0),
                getParentForChildren(),
                isClean());
        underCrvPts_ = null;
      }
      return underCrvPtsBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:commonmodule.TmHzCSG)
  }

  // @@protoc_insertion_point(class_scope:commonmodule.TmHzCSG)
  private static final openfmb.commonmodule.TmHzCSG DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.commonmodule.TmHzCSG();
  }

  public static openfmb.commonmodule.TmHzCSG getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<TmHzCSG>
      PARSER = new com.google.protobuf.AbstractParser<TmHzCSG>() {
    @java.lang.Override
    public TmHzCSG parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<TmHzCSG> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<TmHzCSG> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.commonmodule.TmHzCSG getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

